/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
  
 setsignals.c v 1.9.0 2000/08/21	- Program creation

*****************************************************************************/
#include <errno.h>
#include <signal.h>

int blockallsignals() {
	struct	sigaction	sga ;

	sga.sa_handler= SIG_IGN ;
	sigemptyset(&(sga.sa_mask));
	sga.sa_flags = 0   ;
	if ( sigaction(SIGABRT,&sga,0) < 0 ) {
		printf("Error sigaction SIGABRT : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	if ( sigaction(SIGALRM,&sga,0) < 0 ) {
		printf("Error sigaction SIGALRM : %m") ;
		return(-1) ;
	}
	if ( sigaction(SIGHUP,&sga,0) < 0 ) {
		printf("Error sigaction SIGHUP : %s \n",strerror(errno)) ;
		return(-1) ;
	}

	if ( sigaction(SIGINT,&sga,0) < 0 ) {
		printf("Error sigaction SIGINT : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	if ( sigaction(SIGPIPE,&sga,0) < 0 ) {
		printf("Error sigaction SIGPIPE : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	if ( sigaction(SIGQUIT,&sga,0) < 0 ) {
		printf("Error sigaction SIGQUIT : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	if ( sigaction(SIGTERM,&sga,0) < 0 ) {
		printf("Error sigaction SIGTERM : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	if ( sigaction(SIGUSR1,&sga,0) < 0 ) {
		printf("Error sigaction SIGUSR1 : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	if ( sigaction(SIGUSR2,&sga,0) < 0 ) {
		printf("Error sigaction SIGUSR2 : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	if ( sigaction(SIGTSTP,&sga,0) < 0 ) {
		printf("Error sigaction SIGTSTP : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	if ( sigaction(SIGPOLL,&sga,0) < 0 ) {
		printf("Error sigaction SIGPOLL : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	if ( sigaction(SIGPROF,&sga,0) < 0 ) {
		printf("Error sigaction SIGPROF : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	if ( sigaction(SIGURG,&sga,0) < 0 ) {
		printf("Error sigaction SIGURG : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	if ( sigaction(SIGVTALRM,&sga,0) < 0 ) {
		printf("Error sigaction SIGVTALRM : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	sga.sa_handler= SIG_IGN ;
	sigemptyset(&(sga.sa_mask));
#ifdef HAVE_SA_NOCLDWAIT
	sga.sa_flags = SA_NOCLDSTOP|SA_NOCLDWAIT   ;
#else
	sga.sa_flags = SA_NOCLDSTOP   ;
#endif
	if ( sigaction(SIGCHLD,&sga,0) < 0 ) {
		printf("Error sigaction SIGCHLD : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	return(0) ;
}
