/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
  
 getdatasock.c v 0.0.0 2000/01/11
 			   v 1.6.0 2000/03/24	- Set Receive buffer to TCPWINSIZE
			   						  for the get option
			   v 1.7.1 2000/04/04	- Variable cleaning (detected on SGI)
			   v 1.8.7 2000/05/28	- Change headers
 		 	   v 1.8.9 2000/08/08	- Add timestamp
			   v 1.9.0 2000/08/21	- Use configure to help portage

*****************************************************************************/
#include <unistd.h>
#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <errno.h>

#include <bbftp.h>
#include <common.h>
#include <structures.h>

extern struct	sockaddr_in data_source[MAXPORT] ;
extern int		datasock[MAXPORT] ; 
extern int		timestamp ;

int getdatasock(nbsock) 
	int	nbsock ;
{
	int	i ;
	int tcpwinsize ;
	int	on = 1 ;
	int	addrlen ;
	struct linger li ;
	
	tcpwinsize = TCPWINSIZE ;
	for (i=0 ; i<nbsock ; i++) {
		datasock[i] = socket ( AF_INET, SOCK_STREAM, IPPROTO_TCP ) ;
		if ( datasock[i] < 0 ) {
			datasock[i] = 0 ;
			if (timestamp ) printtime() ;
			printf( "Cannot create data socket: %s\n",strerror(errno));
			return -1 ;
		}
		if ( setsockopt(datasock[i],SOL_SOCKET, SO_REUSEADDR,(char *)&on,sizeof(on)) < 0 ) {
			if (timestamp ) printtime() ;
			printf("Cannot set SO_REUSEADDR on data socket : %s\n",strerror(errno)) ;
			return -1 ;
		}
		if ( setsockopt(datasock[i],IPPROTO_TCP, TCP_NODELAY,(char *)&on,sizeof(on)) < 0 ) {
			if (timestamp ) printtime() ;
			printf("Cannot set TCP_NODELAY on data socket : %s\n",strerror(errno)) ;
			return -1 ;
		}
		if ( setsockopt(datasock[i],SOL_SOCKET, SO_SNDBUF,(char *)&tcpwinsize,sizeof(tcpwinsize)) < 0 ) {
			if (timestamp ) printtime() ;
			printf("Cannot set SO_SNDBUF on data socket : %s\n",strerror(errno)) ;
			return -1 ;
		}	
		if ( setsockopt(datasock[i],SOL_SOCKET, SO_RCVBUF,(char *)&tcpwinsize,sizeof(tcpwinsize)) < 0 ) {
			if (timestamp ) printtime() ;
			printf("Cannot set SO_RECVBUF on data socket : %s\n",strerror(errno)) ;
			return -1 ;
		}	
		
		li.l_onoff = 1 ;
		li.l_linger = 1 ;
		if ( setsockopt(datasock[i],SOL_SOCKET,SO_LINGER,(char *)&li,sizeof(li)) < 0 ) {
			if (timestamp ) printtime() ;
			printf("Cannot set SO_LINGER   on data socket : %s\n",strerror(errno)) ;
			return -1 ;
		}
		if ( bind(datasock[i], (struct sockaddr *) &data_source[i],sizeof(data_source[i])) < 0) {
			if (timestamp ) printtime() ;
			printf("Cannot bind on receive socket : %s\n",strerror(errno)) ;
			return -1 ;
		}
		addrlen = sizeof(data_source[i]) ;
		if (getsockname(datasock[i],(struct sockaddr *)&data_source[i], &addrlen) < 0) {
			if (timestamp ) printtime() ;
			printf("Cannot getsockname on receive socket : %s\n",strerror(errno)) ;
			return -1 ;
       	}
		if (listen(datasock[i], 1) < 0) {
			if (timestamp ) printtime() ;
			printf("Cannot listen on receive socket : %s\n",strerror(errno)) ;
			return -1 ;
		}
	}
	return 0 ;
}
