/****************************************************************************

 Copyright (c) 1999,2000 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
 RETURN :
 	 BB_RET_OK                  = everything OK 
	 BB_RET_FT_NR               = Fatal error no retry needed on this command but connection has been
	                              kept
	 BB_RET_ERROR               = Error but retry possible
	   
 localchangedir.c v 1.8.8 2000/06/02	- Creation of the routine 
		 		  v 1.8.9 2000/08/08	- Add timestamp
 
*****************************************************************************/
#include <errno.h>
#include <stdio.h>
#include <unistd.h>

#include <client.h>

extern char *localdir ;
extern int	timestamp ;

int localchangedir(char *line) 
{
	int	nbitem ; /* Number of item in line, must be equal to 2 */
	char	action[MAXLINE] ;
	char	localfile[MAXLINE] ;
	char	*currentdir ;
	int		savederrno ;

	nbitem = sscanf(line,"%s %s",action,localfile) ;
	
	if (nbitem != 2 ) {
		if (timestamp ) printtime() ;
		printf("Incorrect cd command : %s\n",line) ;
		return BB_RET_FT_NR ;
	}
	if (timestamp ) printtime() ;
	printf(">> COMMAND : %s\n",line) ;
	
	/*
	** We change the directory
	*/
	if ( chdir(localfile) < 0 ) {
		savederrno = errno ;
		if ( savederrno == EACCES ||
				savederrno == ELOOP ||
				savederrno == ENAMETOOLONG ||
				savederrno == ENOTDIR ||
				savederrno == ENOENT ) {
			if (timestamp ) printtime() ;
			printf("Error changing directory %s (%s)\n",localfile,strerror(savederrno)) ;
			return BB_RET_FT_NR ;
		} else {
	 		return BB_RET_ERROR ;
		}
	} else {
		if ( (currentdir = getcwd(NULL,252) ) == NULL ) {
			if (timestamp ) printtime() ;
			printf("Error getting current directory (%s) \n",strerror(errno)) ;
	 		return BB_RET_ERROR ;
		} else {
			free(localdir) ;
			localdir = currentdir ;
			if (timestamp ) printtime() ;
			printf("<< OK : Current local directory is %s\n",localdir) ;
			return BB_RET_OK ;
		}
	}
}

