/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
  
 readmessage.c v 0.0.0  1999/11/24
 			   v 1.6.0  2000/03/24	- Cosmetic...
			   v 1.7.1  2000/04/04	- Portage to SGI (IRIX64)
			   v 1.8.7  2000/05/24	- Set the socket in non block mode
  		 	   v 1.8.9  2000/08/08	- Add timestamp
  		 	   v 1.8.10 2000/08/10	- Portage to Linux
			   v 1.9.0  2000/08/24	- Use configure to help port

*****************************************************************************/
#include <syslog.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

extern int	timestamp ;

int readmessage(int sock,char *buffer,int msglen,int to,int fromchild) 
{
	int		retcode ;
	char	ent[40] ;
	int		nfds ;
	fd_set	selectmask ; /* Select mask */
	struct timeval	wait_timer;
	int		msgsize ;
	int		msgget ;
	int		nbget ;


	if ( fromchild == 1 ) {
		sprintf(ent,"Child %06d : ",getpid()) ;
	} else {
		strcpy(ent,"") ;
	}
	nbget = 0 ;
	msgsize = msglen ;
/*
** start the reading loop
*/
	while ( nbget < msgsize ) {
		nfds = sysconf(_SC_OPEN_MAX) ;
		FD_ZERO(&selectmask) ;
		FD_SET(sock,&selectmask) ;
		wait_timer.tv_sec  = to ;
		wait_timer.tv_usec = 0 ;
		if ( (retcode = select(nfds,&selectmask,0,0,&wait_timer) ) == -1 ) {
			/*
			** Select error
			*/
			if (timestamp ) printtime() ;
			printf("%sRead message : Select error : MSG (%d,%d)\n",ent,msglen,nbget) ;
			return -1 ;
		} else if ( retcode == 0 ) {
			if (timestamp ) printtime() ;
			printf("%sRead message : Time out : MSG (%d,%d)",ent,msglen,nbget) ;
			return -1 ;
		} else {
			msgget = recv(sock,&buffer[nbget],msgsize-nbget,0) ;
			if ( msgget < 0 ) {
				if (timestamp ) printtime() ;
				printf("%sRead message : Receive error : MSG (%d,%d) %s",ent,msglen,nbget,strerror(errno)) ;
				return -1 ;
			} else if ( msgget == 0 ) {
				if (timestamp ) printtime() ;
				printf("%sRead message : Connection breaks : MSG (%d,%d)\n",ent,msglen,nbget) ;
				return -1 ;
			} else {
				nbget = nbget + msgget ;
			}
		}
	}
	return(0) ;
}
