/****************************************************************************

 Copyright (c) 1999,2000 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
 RETURN :
 	 0                  = everything OK 
	 
	 In case of repeated errors this routine exits the program.
	   
 reconnecttoserver.c v 1.8.8 2000/06/02	- Creation of the routine 
  					 v 1.8.9 2000/08/08	- Add timestamp
   					 v 1.9.0 2000/08/28	- Add -r option

*****************************************************************************/
#include <stdio.h>

#include <client.h>

extern char *remotedir ;
extern int	timestamp ;
extern int	globaltrymax;

int	reconnecttoserver(char *username,char *password,int *controlsock) {
	
	int		retcode ;
	int		nbtrycon ;
	char	tmpdir[256] ; 

	for ( nbtrycon = 1 ; nbtrycon <= globaltrymax ; nbtrycon++ ) {
		retcode = connecttoserver(username,password,controlsock) ;
		if ( retcode < -1 ) {
			_exit(1) ;
		} else if ( retcode == 0 ) {
			/*
			** We are connected
			*/
			if ( remotedir != NULL ) {
				/*
				** Before anything we must set the correct remote working directory
				*/
				sprintf(tmpdir,"cd %s",remotedir) ;
				if ( changedir(tmpdir,*controlsock) != BB_RET_OK ) {
					if ( nbtrycon != globaltrymax ) {
						if (timestamp ) printtime() ;
						printf("Retrying connection waiting %d s\n",WAITRETRYTIME) ;
						sleep(WAITRETRYTIME) ;
					} else {
						retcode = 1 ;
					}
				} else {
					return 0 ;
				}
			} else {
				return 0 ;
			}
		} else {
			if ( nbtrycon != globaltrymax ) {
				if (timestamp ) printtime() ;
				printf("Retrying connection waiting %d s\n",WAITRETRYTIME) ;
				sleep(WAITRETRYTIME) ;
			}
		}
	}
	if ( retcode != 0 && nbtrycon == globaltrymax+1) {
		if (timestamp ) printtime() ;
		printf("Maximum try connection reached (%d) aborting connection\n",globaltrymax) ;
		_exit(1) ;
	}
	return 0 ;
}
