/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
  
 setsignals.c v 0.0 1999/11/24
			  v 1.8.7 2000/05/28	- Set socket in non blocking mode
 			  v 1.8.9 2000/08/08	- Better management of SIGCHLD
 			  v 1.8.10 2000/08/10	- Portage to Linux
 			  v 1.9.0 2000/08/21	- Use configure to help portage
									- Change behaviour on SIGINT and SIGTERM

*****************************************************************************/
#include <errno.h>
#include <netinet/in.h>
#include <signal.h>
#include <syslog.h>
#include <sys/socket.h>

#include <bbftp.h>
#include <client.h>
#include <common.h>
#include <structures.h>

extern int		pid_child[MAXPORT] ;
extern pid_t	fatherpid ;
extern int		unlinkfile ;
extern char		localfile[MAXLINE] ;
extern int		timestamp ;

void treatsigint(sig) {
	int	i ;
	
	if ( fatherpid == getpid() ) {
		if ( unlinkfile == 1 ) unlink(localfile) ;
		for (i = 0 ; i<MAXPORT ; i++) {
			if (pid_child[i] != 0) {
				kill(pid_child[i],SIGKILL) ;
			}
		}
		if (timestamp ) printtime() ;
		printf("Interrupt by Ctrl^C\n") ;
		exit(EINTR) ;
	} else {
		exit(EINTR) ;
	}
}

void treatsigterm(sig) {
	int	i ;
	
	if ( fatherpid == getpid() ) {
		if ( unlinkfile == 1 ) unlink(localfile) ;
		for (i = 0 ; i<MAXPORT ; i++) {
			if (pid_child[i] != 0) {
				kill(pid_child[i],SIGKILL) ;
			}
		}
		if (timestamp ) printtime() ;
		printf("Interrupt by signal SIGTERM\n") ;
		exit(EINTR) ;
	} else {
		exit(EINTR) ;
	}
}

int setsignals_b() {
	struct	sigaction	sga ;

	sga.sa_handler= treatsigint ; ;
	sigemptyset(&(sga.sa_mask));
	sga.sa_flags = 0   ;
	if ( sigaction(SIGINT,&sga,0) < 0 ) {
		printf("Error sigaction SIGINT : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	sga.sa_handler= treatsigterm ; ;
	sigemptyset(&(sga.sa_mask));
	sga.sa_flags = 0   ;
	if ( sigaction(SIGTERM,&sga,0) < 0 ) {
		printf("Error sigaction SIGTERM : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	return 0 ;
}
