/****************************************************************************

 Copyright (c) 1999,2000 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
  
 setsignals_c.c v 1.8.9 2000/08/01	- Routine creation
				v 1.8.10 2000/08/10	- Portage to Linux
				v 1.9.0  2000/08/24	- Use configure to help port
 
*****************************************************************************/
#include <errno.h>
#include <signal.h>
#include <sys/types.h>

#include <bbftp.h>
#include <client.h>
/*
** Specific to c
*/
extern int		flagsigusr1 ;
extern int		flagsigusr2 ;
extern int		flagsighup ;
extern pid_t	ownserverpid ;

#ifdef HAVE_SIGINFO
void sigusr1_c(sig,code,scp)
int		sig ;
siginfo_t		*code ;
struct	sigcontext	*scp ;
{
	/*
	** receive USR1 connection can start
	*/

	if ( flagsigusr1 == 2 ) {
		/*
		** Waiting for the first USR1
		*/
		ownserverpid = code->si_pid ;
		flagsigusr1 = 1 ;
	} else {
		if ( code->si_pid == ownserverpid ) {
			if ( flagsigusr1 == 0 ) {
				flagsigusr1 = 1 ;
	 		}
		}
	}
}

void sigusr2_c(sig,code,scp) 
int		sig ;
siginfo_t		*code ;
struct	sigcontext	*scp ;
{
	/*
	** receive USR2 transfer failed
	*/
	if ( code->si_pid == ownserverpid ) {
		if ( flagsigusr2 == 0 ) {
			flagsigusr2 = 1 ;
		}
	}
}
void sighup_c(sig,code,scp) 
int		sig ;
siginfo_t		*code ;
struct	sigcontext	*scp ;
{
	/*
	** receive HUP transfer ok
	*/
	if ( code->si_pid == ownserverpid ) {
		if ( flagsighup == 0 ) {
			flagsighup = 1 ;
		}
	}
}
void sigint_c(sig,code,scp) 
int		sig ;
siginfo_t		*code ;
struct	sigcontext	*scp ;
{
	/*
	** receive INT or TERM transfer ok
	*/
	if ( sig == SIGTERM) {
		printf("Killed\n") ;
	} else {
		printf("Receive Ctrl^C\n") ;
	}
	if ( ownserverpid != 0 ) kill(ownserverpid,SIGTERM) ;
	exit(EINTR) ;
}
#endif

int setsignals_c() {
	struct	sigaction	sga ;

#ifndef HAVE_SIGINFO
	return(-1) ;
}
#else
	sga.sa_handler= sigusr1_c ;
	sigemptyset(&(sga.sa_mask));
	sga.sa_flags = SA_SIGINFO   ;
	if ( sigaction(STARTNEW,&sga,0) < 0 ) {
		printf("Error sigaction STARTNEW : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	sga.sa_handler= sigusr2_c ;
	sigemptyset(&(sga.sa_mask));
	sga.sa_flags = SA_SIGINFO   ;
	if ( sigaction(TRANSFAIL,&sga,0) < 0 ) {
		printf("Error sigaction TRANSFAIL : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	sga.sa_handler= sighup_c ;
	sigemptyset(&(sga.sa_mask));
	sga.sa_flags = SA_SIGINFO   ;
	if ( sigaction(TRANSOK,&sga,0) < 0 ) {
		printf("Error sigaction TRANSOK : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	sga.sa_handler= sigint_c ;
	sigemptyset(&(sga.sa_mask));
	sga.sa_flags = SA_SIGINFO   ;
	if ( sigaction(SIGINT,&sga,0) < 0 ) {
		printf("Error sigaction SIGINT : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	sga.sa_handler= sigint_c ;
	sigemptyset(&(sga.sa_mask));
	sga.sa_flags = SA_SIGINFO   ;
	if ( sigaction(SIGTERM,&sga,0) < 0 ) {
		printf("Error sigaction SIGTERM : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	return 0 ;
}
#endif
