/****************************************************************************

 Copyright (c) 1999,2000 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
  
 setsignals_cd.c v 1.8.9  2000/08/01	- Routine creation
				 v 1.8.10 2000/08/10	- Portage to Linux
				 v 1.9.0  2000/08/24	- Use configure to help port

*****************************************************************************/
#include <errno.h>
#include <netinet/in.h>
#include <signal.h>
#include <syslog.h>
#include <sys/types.h>

#include <bbftp.h>
#include <client.h>
#include <common.h>
#include <structures.h>

extern int		pid_child[MAXPORT] ;
extern int		timestamp;
extern pid_t	fatherpid ;
extern int		unlinkfile ;
extern char		localfile[MAXLINE] ;
/*
** Specific to cd
*/
extern	int		flagsigusr1 ;
extern	pid_t	pidusr1 ;
extern	uid_t	uidusr1 ;

#ifdef HAVE_SIGINFO

void sigusr1_cd_grand_father(sig,code,scp) 
int		sig ;
siginfo_t		*code ;
struct	sigcontext	*scp ;
{
	/*
	** receive USR1 meaning a new command has to be started
	*/
	if ( flagsigusr1 == 0 ) {
		pidusr1 = code->si_pid ;
		uidusr1 = code->si_uid ;
		flagsigusr1 = 1 ;
	}

}

void sigterm_cd_grand_father(sig,code,scp) 
int		sig ;
siginfo_t		*code ;
struct	sigcontext	*scp ;
{
	/*
	** receive SIGTERM
	*/
	exit(EINTR) ;
}

void sigterm_cd_father(sig,code,scp) 
int		sig ;
siginfo_t		*code ;
struct	sigcontext	*scp ;
{
	int		i ;
	/*
	** receive SIGTERM
	*/
	if ( fatherpid == getpid() ) {
		for (i = 0 ; i<MAXPORT ; i++) {
			if (pid_child[i] != 0) {
				kill(pid_child[i],SIGKILL) ;
			}
		}
		if ( unlinkfile == 1 ){
			syslog(LOG_NOTICE,"Erasing file %s",localfile) ;
			 unlink(localfile) ;
		}
		destroyunixsoc() ;
		if (timestamp ) printtime() ;
		syslog(LOG_NOTICE,"In father Interrupt by signal SIGTERM") ;
		exit(EINTR) ;
	} else {
		syslog(LOG_NOTICE,"In child Interrupt by signal SIGTERM") ;
		exit(EINTR) ;
	}
}

#endif

int setsignals_cd_father() {
	struct	sigaction	sga ;

#ifndef HAVE_SIGINFO
	return (-1) ;
}
#else
	sga.sa_handler= sigterm_cd_father ;
	sigemptyset(&(sga.sa_mask));
	sga.sa_flags = SA_SIGINFO   ;
	if ( sigaction(SIGTERM,&sga,0) < 0 ) {
		printf("Error sigaction SIGTERM : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	return 0 ;
}
#endif

int setsignals_cd_grand_father() {
	struct	sigaction	sga ;

#ifndef HAVE_SIGINFO
	return (-1) ;
}
#else
	sga.sa_handler= sigusr1_cd_grand_father ;
	sigemptyset(&(sga.sa_mask));
	sga.sa_flags = SA_SIGINFO   ;
	if ( sigaction(STARTNEW,&sga,0) < 0 ) {
		printf("Error sigaction STARTNEW : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	sga.sa_handler= sigterm_cd_grand_father ;
	sigemptyset(&(sga.sa_mask));
	sga.sa_flags = SA_SIGINFO   ;
	if ( sigaction(SIGTERM,&sga,0) < 0 ) {
		printf("Error sigaction SIGTERM : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	return 0 ;
}

int unsetsignals_cd_grand_father() {
	struct	sigaction	sga ;

	sga.sa_handler= SIG_IGN ;
	sigemptyset(&(sga.sa_mask));
	sga.sa_flags = 0   ;
	if ( sigaction(STARTNEW,&sga,0) < 0 ) {
		printf("Error sigaction STARTNEW : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	if ( sigaction(SIGTERM,&sga,0) < 0 ) {
		printf("Error sigaction SIGTERM : %s \n",strerror(errno)) ;
		return(-1) ;
	}
	return 0 ;
}
#endif
