/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
  
 writemessage.c v 1.6.0  2000/03/24	- Creation of the routine
 			    v 1.7.1  2000/04/04	- Portage to SGI (IRIX64)
			    v 1.8.7  2000/05/24	- Set the socket in non block mode
  				v 1.8.9  2000/08/08	- Add timestamp
  				v 1.8.10 2000/08/10	- Portage to Linux
				v 1.9.0  2000/08/24	- Use configure to help port

*****************************************************************************/
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>


extern int	timestamp ;

int writemessage(int sock,char *buffer,int msglen,int to,int fromchild) 
{
	int		retcode ;
	char	ent[40] ;
	int		nfds ;
	fd_set	selectmask ; /* Select mask */
	struct timeval	wait_timer;

	int		msgsize ;
	int		msgsend ;
	int		nbsent ;

	if ( fromchild == 1 ) {
		sprintf(ent,"Child %06d : ",getpid()) ;
	} else {
		strcpy(ent,"") ;
	}
	nbsent = 0 ;
	msgsize = msglen ;
/*
** start the writing loop
*/
	while ( nbsent < msgsize ) {
		nfds = sysconf(_SC_OPEN_MAX) ;
		FD_ZERO(&selectmask) ;
		FD_SET(sock,&selectmask) ;
		wait_timer.tv_sec  = to ;
		wait_timer.tv_usec = 0 ;
		if ( (retcode = select(nfds,0,&selectmask,0,&wait_timer) ) == -1 ) {
			/*
			** Select error
			*/
			if (timestamp ) printtime() ;
			printf("%sWrite message : Select error : MSG (%d,%d)",ent,msglen,nbsent) ;
			return -1 ;
		} else if ( retcode == 0 ) {
			if (timestamp ) printtime() ;
			printf("%sWrite message : Time Out : MSG (%d,%d)\n",ent,msglen,nbsent) ;
			return -1 ;
		} else {
			msgsend = send(sock,&buffer[nbsent],msgsize-nbsent,0) ;
			if ( msgsend < 0 ) {
				if (timestamp ) printtime() ;
				printf("%sWrite message : Send error %d(%s) : MSG (%d,%d)\n",ent,errno,strerror(errno),msglen,nbsent) ;
				return -1 ;
			} else if (msgsend  == 0 ) {
				if (timestamp ) printtime() ;
				printf("%sWrite message : Connection breaks : MSG (%d,%d)\n",ent,msglen,nbsent) ;
				return -1 ;
			} else {
				nbsent = nbsent + msgsend ;
			}
		}
	}
	return(0) ;
}
