/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
  
 do_daemon.c v 0.0.0  1999/11/24
             v 1.3.0  2000/03/16
             v 1.6.1  2000/03/30	- Use sysconf instead of OPEN_MAX
			 v 1.8.4  2000/04/21	- Seed the randoma generator
			 v 1.8.7  2000/05/24	- Include version.h
			 v 1.8.10 2000/08/11	- Portage to Linux

*****************************************************************************/
#include <netdb.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <stdio.h>
#include <syslog.h>
#include <sys/socket.h>
#include <unistd.h>
#include <sys/time.h>

#include <config.h>
#include <common.h>
#include <version.h>
#include <openssl/err.h>
#include <openssl/rand.h>

extern int be_daemon ;
extern int controlsock ;
extern int msgsock ;

void do_daemon(int argc,char **argv,char **envp)
{

	int	prpg ;
	int	i ;
	struct sockaddr_in server;
	int on = 1;
	char tmpchar[50] ;
	
	char	buffrand[NBITSINKEY] ;
	struct timeval tp ;
	unsigned int seed ;
	
	sprintf(tmpchar,"bbftpd v%s",VERSION) ;
	if (be_daemon == 2) {
		/* Fork - so I'm not the owner of the process group any more */
		i = fork();
		if (i < 0) {
			syslog(LOG_ERR, "Cannot fork %m");
			exit(1);
		}
		/* No need for the parent any more */
		if (i > 0)
			_exit(0);

		prpg = 0 ;
		prpg = setsid () ; 	/* disassoiciate from control terminal */
		if ( prpg < 0 ) {
			syslog(LOG_ERR,"Cannot daemonise: %m") ;
			exit(1) ;
		}
	}
	/* Close off all file descriptors and reopen syslog */
	if (be_daemon == 2) {
		int i ;
		long fds;

	    fds = sysconf(_SC_OPEN_MAX) ;

		closelog();
		for (i = 0; i <= fds; i++) {
			close(i);
		}
		openlog(tmpchar, LOG_PID | LOG_NDELAY, LOG_DAEMON);

		/* junk stderr */
        	(void) freopen("/dev/null", "w", stderr);
	}
	/* Now create the socket we are going to listen on */
	controlsock = socket ( AF_INET, SOCK_STREAM, IPPROTO_TCP ) ;
	if ( controlsock < 0 ) {
		syslog(LOG_ERR, "Cannot create socket to listen on: %m");
		exit(1) ;
	}
	if ( setsockopt(controlsock,SOL_SOCKET, SO_REUSEADDR,(char *)&on,sizeof(on)) < 0 ) {
		syslog(LOG_ERR,"Cannot set SO_REUSEADDR on control socket : %m ") ;
		exit(1) ;
	}
	server.sin_family = AF_INET ;
	server.sin_addr.s_addr = INADDR_ANY ;
	server.sin_port = htons(CONTROLPORT);
	if ( bind (controlsock,(struct sockaddr *) &server, sizeof(server) ) < 0 ) {
		syslog(LOG_ERR,"Error binding control socket : %m ") ;
		exit(1) ;
	}
	if ( listen(controlsock,100) < 0 ) {
		syslog(LOG_ERR,"Error listening control socket : %m ") ;
		exit(1) ;
	}
	
	syslog(LOG_NOTICE,"Starting bbftpd for babar") ;
	if ( set_father_signals() < 0 ) {
		exit(1) ;
	}
	/*
	** Load the error message from the crypto lib
	*/
	ERR_load_crypto_strings() ;
	/*
	** Initialize the buffrand buffer which is giong to be used to initialize the 
	** random generator
	*/
	/*
	** Take the usec to initialize the random session
	*/
	gettimeofday(&tp,NULL) ;
	seed = tp.tv_usec ;
	srandom(seed) ;
	for (i=0; i < sizeof(buffrand) ; i++) {
		buffrand[i] = random() ;
	}
	/*
	** Initialize the random generator
	*/
	RAND_seed(buffrand,NBITSINKEY) ;
	while (1) {
		int pid;

		msgsock = accept(controlsock, 0, 0);
		if (msgsock < 0) {
 			syslog(LOG_ERR, "Accept failed: %m");
			sleep(1);
			continue;
		}
	        /* Fork off a handler */
		pid = fork();
		if (pid < 0) {
			syslog(LOG_ERR, "failed to fork: %m");
 			sleep(1);
			continue;
		}
		if (pid == 0) {
			/* I am that forked off child */
			closelog();
			/* Make sure that stdin/stdout are the new socket */
			/* Only parent needs controlsock */
			if (controlsock != 0 && controlsock != 1)
				close(controlsock);
				openlog(tmpchar, LOG_PID | LOG_NDELAY, LOG_DAEMON);
           		return;
       		 }

        	/* I am the parent */
		close(msgsock);
	
	}
}

