/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
 RETURN:
 		0  calling program return to main loop
		-1 calling program exit
 
 readcontrol.c v 0.0.0 1999/11/24
               v 1.2.0 2000/01/26
               v 1.3.0 2000/03/20   - Externalise the socket creation in order
                                      to be able to retry the connection if we
                                      where interrupted by a signal.  
                                      (createreceivesock.c) 
									  Bug shown by amlutz
                                	- In case of problem in the father send
                                  	  a reply bad but prevent children to resend
									  it by setting childendinerror to 1 
									  Bug shown by amlutz 
               v 1.4.0 2000/03/22	- Use new encryption protocol
			   v 1.6.0 2000/03/24	- Reorganize the logic to split readcontrol
			   						  in several files
									- Add sendafile call 
			   v 1.8.5 2000/04/28	- Add createadir call
 			   v 1.8.7 2000/05/24	- Modify headers
 			   v 1.8.8 2000/06/02	- Add changetodir call
 			   						- Add sendlist call
			   v 1.9.0  2000/08/18	- Use configure to help portage
			   
*****************************************************************************/
#include <netinet/in.h>
#include <syslog.h>

#include <bbftpd.h>
#include <common.h>
#include <status.h>
#include <structures.h>
#include <version.h>

extern int state ;
extern int msgsock ;
extern int unlinkfile ;
extern int pid_child[MAXPORT] ;

int readcontrol() {

	int		retcode ;
	int		i ;
	
	char	receive_buffer[MAXMESSLEN] ;
	struct message *msg ;
	char	logmessage[256] ;
	
	/*
	** Read the message on control socket
	*/
	if ( (retcode = readmessage(msgsock,receive_buffer,MINMESSLEN,CONTROLSOCKTO)) < 0 ) {
		/*
		** It is starting badly !!!
		*/
		return(retcode) ;
	}
	msg = (struct message *) receive_buffer ;
	/*
	** Depending on the state the accepted message may be different
	*/
	switch (state) {
		/*
		** State connected :
		**		MSG_LOG only and one chance to get logged
		*/
		case S_CONN :{
			if ( msg->code == MSG_LOG ) {
				/*
				** It seems that it is the message we were waiting
				** so lets decrypt 
				*/
				if ( loginsequence() < 0 ) {
					/*
					** The login failed, do not wait for a new one
					*/
					return -1 ;
				}
				state = S_LOGGED ;
				sprintf(logmessage,"bbftpd version %s : OK",VERSION) ;
				reply(MSG_OK,logmessage) ;
				return 0  ;
			} else {
				/*
				** Unkown message, disconnect
				*/
				syslog(LOG_ERR,"Unkown message in connected state : %d",msg->code) ;
				reply(MSG_BAD,"Unkown message in connected state") ;
				return -1 ;
			}
		}
		case S_LOGGED : {
			/*
			** Initilize the pid array
			*/
			for ( i=0 ; i< MAXPORT ; i++) {
				pid_child[i] = 0 ;
			}
			unlinkfile = 0 ;
			switch (msg->code) {
				case MSG_STORE :
				case MSG_STORE_C : {
					retcode = storeafile(msg->code) ;
					return retcode ;
				}
				case MSG_RETR :
				case MSG_RETR_C: {
					retcode = sendafile(msg->code) ;
					return retcode ;
				}
				case MSG_RETR_RFIO :
				case MSG_RETR_RFIO_C: {
					retcode = sendafilerfio(msg->code) ;
					return retcode ;
				}
				case MSG_MKDIR :{
					retcode = createadir(msg->code,msg->msglen) ;
					return retcode ;
				}
				case MSG_CHDIR :{
					retcode = changetodir(msg->code,msg->msglen) ;
					return retcode ;
				}
				case MSG_LIST :{
					retcode = sendlist(msg->code,msg->msglen) ;
					return retcode ;
				}
				default : {
					syslog(LOG_ERR,"Unkown message in logged state") ;
					reply(MSG_BAD,"Unkown message in logged state") ;
					return 0 ;
				}
			}
		}
		default :
			syslog(LOG_ERR,"Receive message in state %d",state) ;
			return -1 ;
	}
}
