/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
  
 readmessage.c v 0.0.0  1999/11/24
 			   v 1.6.0  2000/03/24	- Take the readmessage routine from 
			   						  bbftpc which is more flexible the
									  only difference is that this one is
									  logging into syslog
			   v 1.6.1  2000/03/24	- Portage to OSF1
					 				- Set the socket in non block mode
 			   v 1.8.7  2000/05/30	- Portage to IRIX64
 			   v 1.8.10 2000/08/11	- Portage to Linux
			   v 1.9.0 2000/08/24	- Use configure to help port

*****************************************************************************/
#include <errno.h>
#include <syslog.h>
#include <sys/time.h>
#include <unistd.h>

#include <daemon.h>


int readmessage(int sock,char *buffer,int msglen,int to) 
{
	int	nbget ;
	int	retcode ;
	int		nfds ;
	fd_set	selectmask ; /* Select mask */
	struct timeval	wait_timer;

	nbget = 0 ;
/*
** start the reading loop
*/
	while ( nbget < msglen ) {
		nfds = sysconf(_SC_OPEN_MAX) ;
		FD_ZERO(&selectmask) ;
		FD_SET(sock,&selectmask) ;
		wait_timer.tv_sec  = to ;
		wait_timer.tv_usec = 0 ;
		if ( (retcode = select(nfds,&selectmask,0,0,&wait_timer) ) == -1 ) {
			/*
			** Select error
			*/
			syslog(LOG_ERR,"Read message : Select error : MSG (%d,%d)",msglen,nbget) ;
			return -1 ;
		} else if ( retcode == 0 ) {
			syslog(LOG_ERR,"Read message : Time out : MSG (%d,%d)",msglen,nbget) ;
			return -1 ;
		} else {
			retcode = recv(sock,&buffer[nbget],msglen-nbget,0) ;
			if ( retcode < 0 ) {
				syslog(LOG_ERR,"Read message : Receive error : MSG (%d,%d) : %m",msglen,nbget) ;
				return -1 ;
			} else if ( retcode == 0 ) {
				syslog(LOG_ERR,"Read message : Connexion breaks") ;
				return -1 ;
			} else {
				nbget = nbget + retcode ;
			}
		}
	}
	return(0) ;
}
