/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
  
 structures.h v 0.0.0  1999/11/24
              v 1.2.0  2000/11/24
			  v 1.4.0  2000/03/22  	- Add message for crypt mode for
			  						  username and password
			  v 1.6.0  2000/03/24  	- New parameters for get implementation
			  v 1.6.1  2000/03/30  	- Portage to OSF1
			  v 1.8.0  2000/04/14	- Introduce RSA Cryptage
			  v 1.8.10 2000/08/10  	- Portage to Linux
			  v 1.9.0  2000/08/18	- Use configure to help portage
			  
*****************************************************************************/

#define MAXLEN	200
#define MAXLENFILE 500
#define MAXPORT 10
#define READBUFLEN 256000
/*
** Message code 
*/
#ifdef WORDS_BIGENDIAN
#define MSG_OK				0x00000000
#define MSG_LOG				0x00000001
#define MSG_STORE			0x00000002
#define MSG_BAD				0x00000003
#define MSG_ACK				0x00000004
#define MSG_STORE_C 		0x00000005
#define MSG_CRYPT			0x00000006
#define MSG_RETR			0x00000007
#define MSG_RETR_C			0x00000008
#define MSG_RETR_OK			0x00000009
#define MSG_RETR_RFIO		0x0000000A
#define MSG_RETR_RFIO_C		0x0000000B
#define MSG_RETR_START		0x0000000C
#define MSG_ABR				0x0000000D
#define MSG_BAD_NO_RETRY	0x0000000E
#define MSG_MKDIR			0x0000000F
#define MSG_CHDIR			0x00000010
#define MSG_LIST			0x00000011
#define MSG_LIST_REPL		0x00000012
#define MSG_CREATE_ZERO		0x00000013
#else
#define MSG_OK				0x00000000
#define MSG_LOG				0x01000000
#define MSG_STORE			0x02000000
#define MSG_BAD				0x03000000
#define MSG_ACK				0x04000000
#define MSG_STORE_C 		0x05000000
#define MSG_CRYPT			0x06000000
#define MSG_RETR			0x07000000
#define MSG_RETR_C			0x08000000
#define MSG_RETR_OK			0x09000000
#define MSG_RETR_RFIO		0x0A000000
#define MSG_RETR_RFIO_C		0x0B000000
#define MSG_RETR_START		0x0C000000
#define MSG_ABR				0x0D000000
#define MSG_BAD_NO_RETRY	0x0E000000
#define MSG_MKDIR			0x0F000000
#define MSG_CHDIR			0x10000000
#define MSG_LIST			0x11000000
#define MSG_LIST_REPL		0x12000000
#define MSG_CREATE_ZERO		0x13000000
#endif

/*
** Crypt type
*/
#ifdef WORDS_BIGENDIAN
#define CRYPT_BR	0x00000001	/* Simple "brouillage" */
#define CRYPT_RSA_PKCS1_OAEP_PADDING	0x00000002	/* Cryptage RSA */
#else
#define CRYPT_BR	0x01000000	/* Simple "brouillage" */
#define CRYPT_RSA_PKCS1_OAEP_PADDING	0x02000000	/* Cryptage RSA */
#endif

#ifdef WORDS_BIGENDIAN
#define DATA_NOCOMPRESS 0x00000000
#define DATA_COMPRESS   0x00000001
#else
#define DATA_NOCOMPRESS 0x00000000
#define DATA_COMPRESS   0x01000000
#endif

#define NBYTESRSA	128

/*
** message is only used as the minimum structure to get a message 
*/

struct message {
	int	code ;			/* Message code */
	int	msglen ;		/* Message length in bytes */
} ;

struct mess_rsa {
	unsigned char	cryptuser[NBYTESRSA] ;	
	unsigned char	cryptpass[NBYTESRSA] ;	
	int		numuser ;
	int		numpass ;
} ;

struct mess_store {
	char	filename[MAXLENFILE] ;		/* Filename to store or to get*/
	my64_t	filesize ;			/* Size of the file (0 for a get) */
	int		blocksize ;			/* Blocksize (not used)*/
	struct sockaddr_in remote_host ;	/* Adresse of remote host */
	int		nbport ;			/* Number of ports */
	int		port[MAXPORT] ;			/* Ports Number */
} ;

struct mess_compress {
	int	code ;
	int	datalen ;
} ;

struct mess_sec {
	int	crtype ;
	int pubkeylen ;
	int expolen ;
} ;

struct mess_retr_ok {
	my64_t	filesize ;
} ;

#define USERMESS struct mess_user
#define USERMESSLEN sizeof(USERMESS)

#define MINMESS  struct message
#define RSAMESS struct mess_rsa
#define STORMESS struct mess_store
#define COMPMESS struct mess_compress
#define CRYPTMESS struct mess_sec
#define RETROKMESS struct mess_retr_ok
#define MINMESSLEN sizeof(MINMESS)
#define RSAMESSLEN sizeof(RSAMESS)
#define STORMESSLEN sizeof(STORMESS)
#define COMPMESSLEN sizeof(COMPMESS)
#define CRYPTMESSLEN sizeof(CRYPTMESS)
#define RETROKMESSLEN sizeof(RETROKMESS)
#define MAXMESSLEN STORMESSLEN
