/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
  
 
*****************************************************************************/
#include <stdio.h>

#include <openssl/rsa.h>
#include <openssl/err.h>
#include <openssl/rand.h>

main(argc, argv, envp)
	int argc;
	char **argv;
	char **envp;
{
	RSA		*myrsa, *hisrsa ;
	FILE	*fp ;
	
	unsigned long	publicexponent ;
	int		modulussize ;
	char	buffrand[1024] ;
	
	unsigned char	pubkey[2000] ;
	unsigned char	pubexponent[2000] ;
	int		retcode ;
	int		lenkey ;
	int		lenexpo ;
	
	unsigned char	from[1000] ;
	unsigned char	fromcrypted[1000] ;
	unsigned char	fromdecrypted[1000] ;
	int lencrypted ;
	int lendecrypted ;

	ERR_load_crypto_strings() ;
	RAND_seed(buffrand,1024) ;
	
	
	publicexponent = 3 ;
	modulussize = 1024 ;
	
	if ( (myrsa = RSA_generate_key(modulussize,publicexponent,NULL,NULL)) == NULL) {
		printf("%s\n",ERR_error_string(ERR_get_error(),NULL) ) ;
		exit(0) ;
	}
	fp = fopen("RSA.results","w") ;
	RSA_print_fp(fp,myrsa,10) ;
	
	retcode = BN_bn2mpi(myrsa->n,NULL) ;
	printf("len RSA->n %d\n",retcode ) ;
	retcode = BN_bn2mpi(myrsa->e,NULL) ;
	printf("len RSA->e %d\n",retcode ) ;
	
	lenkey  = BN_bn2mpi(myrsa->n,pubkey) ;
	lenexpo = BN_bn2mpi(myrsa->e,pubexponent) ;
	
	if ( (hisrsa = RSA_new()) == NULL) {
		printf("%s\n",ERR_error_string(ERR_get_error(),NULL) ) ;
		exit(0) ;
	}
	
	hisrsa->n = BN_new() ;
	hisrsa->e = BN_new() ;
	BN_mpi2bn(pubkey,lenkey,hisrsa->n) ;
	BN_mpi2bn(pubexponent,lenexpo,hisrsa->e) ;
	
	printf("RSA_size(myrsa) : %d\n",RSA_size(myrsa)) ;
	printf("RSA_size(hisrsa) : %d\n",RSA_size(hisrsa)) ;
	
	strcpy(from,"farrache") ;
	
	lencrypted = RSA_public_encrypt(8,from,fromcrypted,hisrsa,RSA_PKCS1_OAEP_PADDING) ;
	printf("lencrypted : %d\n",lencrypted) ;
	fromcrypted[lencrypted] = '\0' ;
	printf("Char crypted : %s\n",fromcrypted) ;
	lendecrypted = RSA_private_decrypt(lencrypted,fromcrypted,fromdecrypted,myrsa,RSA_PKCS1_OAEP_PADDING) ;
	printf("lendecrypted : %d\n",lendecrypted) ;
	fromdecrypted[lendecrypted] = '\0' ;
	printf("Char decrypted : %s\n",fromdecrypted) ;

	
	
	
}
