/****************************************************************************

 Copyright (c) 1999 Gilles Farrache In2p3 Computing Center
 All rights reserved.
 
*****************************************************************************/
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>

typedef struct gilles
  {
    int si_signo;               /* Signal number.  */
    int si_errno;               /* If non-zero, an errno value associated with
                                   this signal, as defined in <errno.h>.  */
    int si_code;                /* Signal code.  */
	union {
		int	pad[128] ;
		
		struct {
			pid_t	pid ;
			pid_t	uid ;
		} toto ;
	} _sifields ;
  } gilles_t ;		

void in_sighup(sig,code,scp) 
int		sig ;
gilles_t		*code ;
struct	sigcontext	*scp ;
{
	/* Receive sighup in order to restart*/
	printf("Receive SIGHUP\n") ;
	printf("pid = %d\n",code->_sifields.toto.pid) ;
	printf("uid = %d\n",code->_sifields.toto.uid) ;
	printf("signo = %d\n",code->si_signo) ;
	printf("errno = %d\n",code->si_errno) ;
	printf("code = %d\n",code->si_code) ;
}

main() {
	struct	sigaction	sga ;

  
	
	sga.sa_handler = in_sighup ;
	sigemptyset(&(sga.sa_mask));
	sga.sa_flags = SA_SIGINFO  ;
	if ( sigaction(42,&sga,0) < 0 ) {
		printf("Error sigaction SIGHUP : %s",strerror(errno)) ;
		exit(-1) ;
	}
sl:
	sleep(10) ;
	raise(42) ;
	goto sl ;
}
#ifdef SUNOS
int sigsetmask(mask)
        int mask;
{
        return(sigprocmask(SIG_SETMASK,(sigset_t *)&mask,(sigset_t *)NULL));
}
struct sigvec
{ void (*sv_handler)();
  int sv_mask;
  int sv_flags;
};

int sigvec(signal,invec,outvec)
        int signal;
        struct sigvec *invec,*outvec;
{
        struct sigaction action,oaction;
        int rc;

        action.sa_handler=invec->sv_handler;
        (void) memset(&(action.sa_mask),0,sizeof(sigset_t));
        (void) memmove(&(action.sa_mask),&(invec->sv_mask),sizeof(int));
        action.sa_flags=invec->sv_flags;

        rc=sigaction(signal,&action,&oaction);
        if (rc) return(rc);

        outvec->sv_handler=oaction.sa_handler;
        (void) memmove(&(outvec->sv_mask),&(oaction.sa_mask),sizeof(int));
        outvec->sv_flags=oaction.sa_flags;

        return(0);
}
#endif
